/* 
 *
 *  Copyright 1996 Claude Lecommandeur. See COPYRIGHT file for details
 *
 *  Author:  Claude Lecommandeur [ Claude.Lecommandeur@epfl.ch ][ August 1996 ]
 *
 */

#include <StubPreamble.h>

#ifndef KAFFE
     typedef short   jshort;
     typedef long    jint;
     typedef int64_t jlong;
#endif

#include <java_awt_Font.h>
#include <java_awt_Rectangle.h>
#include <java_awt_Image.h>
#include <java_awt_image_ImageObserver.h>

#include <kaffe_awt_simple_NativeWindow.h>
#include <kaffe_awt_simple_NativeGraphics.h>
#include <kaffe_awt_simple_NativeFontMetrics.h>
#include <kaffe_awt_simple_NativeEvent.h>
#include <kaffe_awt_simple_NativeDisplay.h>

typedef struct Hkaffe_awt_simple_NativeDisplay		*NativeDisplay;
typedef struct Hkaffe_awt_simple_NativeWindow		*NativeWindow;
typedef struct Hkaffe_awt_simple_NativeGraphics		*NativeGraphics;
typedef struct Hkaffe_awt_simple_NativeFontMetrics	*NativeFontMetrics;
typedef struct Hkaffe_awt_simple_NativeEvent		*NativeEvent;

typedef struct Hjava_awt_Image			*JavaImage;
typedef struct Hjava_awt_Color			*JavaColor;
typedef struct Hjava_awt_image_ImageObserver	*JavaImageObserver;
typedef struct Hjava_awt_Font			*JavaFont;
typedef struct Hjava_awt_FontMetrics		*JavaFontMetrics;
typedef struct Hjava_lang_String		*JavaString;
typedef struct Hjava_awt_Rectangle		*JavaRectangle;


#define MAXSTRINGLEN 1024
#define MAXFONTS 128
#define MAXGCS 128

typedef struct _XFont {
    int  iid;
    Font fid;
    XFontStruct *fontstruct;
} *XFont;

typedef struct _XGC {
    int  gid;
    GC   gc;
} *XGC;

#define DoubleClickTime 250 /* max milisecs for double clicks. */

extern Display	*dpy;  /* only one display at a time (for now) */
extern XFont	Xfonts [MAXFONTS];
extern XGC	Xgcs [MAXGCS];
extern int	nfonts;
extern Bool	debug;
extern Bool	lockdebug;
extern Bool	busydisplay;
extern int	cursorFont;

extern int	getcolor ();
extern int	allocateGC ();
extern void	freeGC ();

#define LOCKDISPLAY(where)	if (lockdebug) fprintf (stderr, "LOCKDISPLAY : %s\n", where)
#define RELEASEDISPLAY(where) 	if (lockdebug) fprintf (stderr, "RELEDISPLAY : %s\n", where)
